function handleIncorrect() {
	if (!maingame.device.desktop) {
		document.getElementById("turn").style.display = "block";
	}
}

function handleCorrect() {
	if (!maingame.device.desktop) {
		document.getElementById("turn").style.display = "none";
	}
}

function ng_getCookie(cname){
	var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i = 0; i <ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length,c.length);
        }
    }
    return "";
}

function submitMyScore(score){
	console.log(score+" submitted!");
    
    var info = ng_getCookie("ni_auth_key");
    var token = ng_getCookie("ni_auth_token");
    
    if(window.parent.submitGameScore)
    {
        window.parent.submitGameScore(score,info,token);        
    }
}

function toggleSound(evt) {
	if (gamePaused == false) {
		if (isSoundOn == true) {
			muteBtn.frame = 1;
			evt.game.sound.mute = true;
			isSoundOn = false;
		} else if (isSoundOn == false) {
			muteBtn.frame = 0;
			evt.game.sound.mute = false;
			isSoundOn = true;
		}
	}
}
function getRandomInt(min, max) {
	return Math.floor(Math.random() * (max - min + 1)) + min;
}

function getRandomFloat(min, max) {
	return Math.random() * (max - min) + min;
}
function createText(game, x, y, text, fill, font, fontSize, stroke, strokeThickness, wordWrap, wordWrapWidth, shadow, capitalize) {

	if (capitalize)
		textObj = game.add.text(x, y, text.toUpperCase());
	else
		textObj = game.add.text(x, y, text);
	textObj.fill = fill;

	textObj.font = font;
	textObj.fontSize = fontSize;
	textObj.stroke = stroke;
	textObj.strokeThickness = strokeThickness;
	textObj.wordWrap = wordWrap;
	textObj.wordWrapWidth = wordWrapWidth;
	if (shadow == true) {
		textObj.setShadow(2, 2, 'rgba(0,0,0,0.5)', 5);
	}
	return textObj;
} 

var Game = {};
var stageWidth = 1920;
var stageHeight = 1080;

var rulesTxtFreeStyle = "To win the game, you have to put the coins through the four pockets on the corners of the board. Make use of the striker to hit and pocket the coins, as you cannot directly move the coins. The striker can only be hit from your side of the board, and only when it is placed between the two parallel lines.\n\n You can pocket more than one coin in a single hit. Pocketing coins will give you another chance whereas if no coins are pocketed, your turn ends. \n\n The queen coin must always have a cover, which means that once the queen (red coin) is pocketed, it must immediately be followed by pocketing another coin during the same turn. If you're unable to do so, the queen will return to the centre of the board.";
var rulesModeFreeStyle = "In this mode, the player who pockets the most valued coins, wins. Black coins = 10 points each. White coins = 20 points each. The queen = 50 points (when taken with a cover which also grants additional points). \n\n If you pocket the last coin before the queen, two of your coins will be returned to the board. If you pocket the striker, one of your coins must be put back on the board and your turn will end. Whereas if you pocket the striker along with a coin, two coins must be put back on the board and your turn will end.";
var rulesModeBlack = "In this mode, the player has to select his/her color of choice. Once selected, the player with the white coins starts the game. The player must only pocket the coins they have selected. The one who collects all their coins first, wins.\n\n If you pocket your opponent’s coin, your turn will end. However, if you pocket one of your coins along with your opponent’s coins, you can continue your turn. \n\n After you pocket the queen, the cover coin will have to be of your color. If you pocket the queen with your opponent’s coin, your turn ends and the queen is placed back on the board. If you pocket your last coin before the queen, the game ends and you lose. If you pocket your opponents last coin as the cover to the queen, the game ends and you lose. \n\n If you pocket any coin along with the striker, then the pocketed coin and a collected coin must be placed back on the board. However, your turn would continue. If you pocket the striker with one of your coins and your opponents coin, you must put one of your own coins on the board. Your turn would continue. \n\n If you pocket the striker with the queen and your own coin, the collected coin and the queen must be placed back on the board and your turn would continue. If you pocket the striker with the queen and your opponents coin, then a collected coin and the queen must be placed back on the board and your turn would end."

//Fonts
var customFont1 = 'bigboss';
var customFont2 = 'Chalkduster';
var customFont3 = 'Samurai';
var customFont4 = 'digital';

//Game Flags
var gameStarted = false;
var enemySpotted = false;
var unlockedMiniGames = 1;
var totalLevels = 10;
var gameOverFlag = false;
var unlockedLevels = 1;

//Sounds
var sampleSound;
var correctSound;
var wrongSound;
var backgroundSound;
var buttonSound;
var hitSound;
var winSound;
var boardSound;
var holeSound;

var scopes = [];
var deletePool = [];
var miniGamesList = [];
var miniGamesTitles = [];
var levelButtons = [];
var currentMode = '';

var isSoundOn = true;
var muteBtn = undefined;
var gamePaused = false;

Game.Boot = function(game){
	
}

Game.Boot.prototype = {
	
	init:function(){
	},
	
	preload:function(){
		this.load.image('loadingBg','assets/loader/loading_bg.jpg');
		this.load.image('overlayBg','assets/loader/overlay_bg.png');
		this.load.image('gameTitle', 'assets/menu/game_title.png');
		this.load.image('preloadBg', 'assets/loader/line.png');
		this.load.image('preloadBar', 'assets/loader/lineFill.png');
	},
	
	
	
	create:function(){
		
		maingame = this.game;
		
		this.stage.disableVisibilityChange = false;

		this.stage.backgroundColor = '#ffffff';

		this.scale.forceLandscape = true;
		this.scale.forceOrientation(true, false);
		this.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;

		this.game.scale.forceOrientation(true, false);
		this.game.scale.enterIncorrectOrientation.add(handleIncorrect);
		this.game.scale.leaveIncorrectOrientation.add(handleCorrect);

		this.scale.pageAlignHorizontally = true;
		this.scale.pageAlignVertically = true;
		
		this.game.scale.fullScreenScaleMode = Phaser.ScaleManager.SHOW_ALL;

		this.scale.refresh();

		firstRunLandscape = this.game.scale.isLandscape;

		// if (firstRunLandscape)
		this.state.start('Preloader');

		this.add.sprite(0, 0, ''); 
	},
	
	update:function() {
		// if(!this.game.scale.isLandscape) {
			// handleIncorrect();	
		// } else if(this.game.scale.isLandscape) {
			// handleCorrect();
        // }
	}
	
}
