Game.GameScene = function(game){
	this.numCoins = 18;
	coinsLeft = this.numCoins;
	coins = [];
	newCoins = [];
	spinning = false;
	directionCircle = undefined;
	striker = undefined;
	analog = undefined;
	isDragging = false;
	isDraggingLever = false;
	avgSpeed = 30;
	strikerAi = false;
	turn = 'player';
	timeEvent = undefined;
	points = {'whiteCoin':20,'blackCoin':10,'queenCoin':50};
	coinPlaced = false;
	playerCoins = {'whiteCoin':0,'blackCoin':0};
	compCoins = {'whiteCoin':0,'blackCoin':0};
	minusCoinType = '';
	placeee = false;
	playerCoinsText = {'whiteCoin':'0','blackCoin':'0'};
	compCoinsText = {'whiteCoin':'0','blackCoin':'0'};
	queenPocketed = false;
	followPocketed = false;
	firstQueenPlace = false;
	queenDone = false;
	spinEnabled = false;
}

Game.GameScene.prototype = {
	
	init:function(){
		coinsLeft = this.numCoins;
		coins = [];
		newCoins = [];
		spinning = false;
		directionCircle = undefined;
		striker = undefined;
		analog = undefined;
		isDragging = false;
		isDraggingLever = false;
		avgSpeed = 30;
		strikerAi = false;
		turn = 'player';
		timeEvent = undefined;
		points = {'whiteCoin':20,'blackCoin':10,'queenCoin':50};
		coinPlaced = false;
		playerCoins = {'whiteCoin':0,'blackCoin':0};
		compCoins = {'whiteCoin':0,'blackCoin':0};
		minusCoinType = '';
		placeee = false;
		playerCoinsText = {'whiteCoin':'0','blackCoin':'0'};
		compCoinsText = {'whiteCoin':'0','blackCoin':'0'};
		queenPocketed = false;
		followPocketed = false;
		queenDone = false;
		gameOverFlag = false;
	},
	
	preload:function(){ 
		
		coinsLeft = this.numCoins;
		
		for(i=0;i<coins.length;i++){
			coins[i].destroy();
		}
		coins = [];
		
		for(i=0;i<newCoins.length;i++){
			newCoins[i].destroy();
		}
		newCoins = [];
		gamePaused = false;
		gameOverFlag = false;
	},
	
	/*showFullScreen:function(){
		if (this.game.scale.isFullScreen)
	    {
	        this.game.scale.stopFullScreen();
	        fullscreenBtn.frame = 0;
	    }
	    else
	    {
	        this.game.scale.startFullScreen(false);
	        fullscreenBtn.frame = 1;
	    }
	}, */
	
	create:function(){
		
		backgroundSound.stop();
		
		this.game.physics.startSystem(Phaser.Physics.P2JS);
		this.game.physics.p2.restitution = 0.9;
		this.game.physics.startSystem(Phaser.Physics.ARCADE);
		
		gameBg = this.game.add.sprite(0,0,'gameBg');
		gameBoard = this.game.add.sprite(430,23,'gameBoard');
		
		coinsGroup = this.game.add.group();
		
		if(!this.game.device.iOS)
			//fullscreenBtn = this.game.add.button(1680,50, 'fullscreenBtn',this.showFullScreen, this);
		
		hole1 = this.game.add.sprite(540,132,'hole');
		this.game.physics.p2.enable(hole1, true);
		hole1.body.static = true;
		hole1.body.setCircle(5);
		hole1.body.data.shapes[0].sensor = true;
		hole1.body.onBeginContact.add(this.coinHoleCollision, this);
		
		hole2 = this.game.add.sprite(1355,132,'hole');
		this.game.physics.p2.enable(hole2, true);
		hole2.body.static = true;
		hole2.body.setCircle(5);
		hole2.body.data.shapes[0].sensor = true;
		hole2.body.onBeginContact.add(this.coinHoleCollision, this);
		
		hole3 = this.game.add.sprite(540,945,'hole');
		this.game.physics.p2.enable(hole3, true);
		hole3.body.static = true;
		hole3.body.setCircle(5);
		hole3.body.data.shapes[0].sensor = true;
		hole3.body.onBeginContact.add(this.coinHoleCollision, this);
		
		hole4 = this.game.add.sprite(1355,945,'hole');
		this.game.physics.p2.enable(hole4, true);
		hole4.body.static = true;
		hole4.body.setCircle(5);
		hole4.body.data.shapes[0].sensor = true;
		hole4.body.onBeginContact.add(this.coinHoleCollision, this);
		
		comphud = this.game.add.sprite(60,200,'hud');
		comText = createText(this.game,175, 200, 'COM', '#000', customFont3, 65, '#000', 0, false,0,false,true);
		compCoinsTxtObj = {};
		compCoinsTxtObj['blackCoin'] = createText(this.game,105, 270, compCoins['blackCoin']+'', '#f00', customFont4, 50, '#000', 0, false,0,false,true);
		compCoinsTxtObj['whiteCoin'] = createText(this.game,275, 270, compCoins['whiteCoin']+'', '#f00', customFont4, 50, '#000', 0, false,0,false,true);
		
		
		playerhud = this.game.add.sprite(60,800,'hud');
		playerText = createText(this.game,175, 800, 'YOU', '#000', customFont3, 65, '#000', 0, false,0,false,true);
		playerCoinsTxtObj = {};
		playerCoinsTxtObj['blackCoin'] = createText(this.game,105, 870, playerCoins['blackCoin']+'', '#f00', customFont4, 50, '#000', 0, false,0,false,true);
		playerCoinsTxtObj['whiteCoin'] = createText(this.game,275, 870, playerCoins['whiteCoin']+'', '#f00', customFont4, 50, '#000', 0, false,0,false,true);
		
		this.arrangeCoins();
		
		spinDial = this.game.add.sprite(950,545,'spinDial');
		spinDial.anchor.set(0.5);
		spinDial.inputEnabled = true;
		spinDial.events.onInputDown.add(this.enableSpin, this);
		spinDial.events.onInputUp.add(this.disableSpin, this);
		
		bounds = new Phaser.Rectangle(502, 99, 892, 890);
		// var graphics = this.game.add.graphics(bounds.x, bounds.y);
    	// graphics.lineStyle(4, 0xffd900, 1);
    	// graphics.drawRect(0, 0, bounds.width, bounds.height);
		
		strikerBounds = new Phaser.Rectangle(650, 832, 620, 110);
		
    	customBounds = { left: null, right: null, top: null, bottom: null };
    	
    	// game.world.setBounds(0, 0, 1600, 1200);
    	// this.game.world.setBounds(bounds.x, bounds.y, bounds.width, bounds.height);    
    	// if (this.game.camera.bounds)    {        
    		//  The Camera can never be smaller than the game size        
    		// this.game.camera.bounds.setTo(bounds.x, bounds.y, bounds.width, bounds.height);    
    	// }   this.game.physics.setBoundsToWorld();

		leftWall = this.game.add.sprite(405,500,'overlayBg');
		leftWall.scale.setTo(0.1,1);
		this.game.physics.p2.enable(leftWall, false);
		leftWall.body.static = true;
		leftWall.alpha = 0;
		
		rightWall = this.game.add.sprite(1490,500,'overlayBg');
		rightWall.scale.setTo(0.1,1);
		this.game.physics.p2.enable(rightWall, false);
		rightWall.body.static = true;
		rightWall.alpha = 0;
		
		topWall = this.game.add.sprite(500,45,'overlayBg');
		topWall.scale.setTo(1,0.1);
		this.game.physics.p2.enable(topWall, false);
		topWall.body.static = true;
		topWall.alpha = 0;
		
		botWall = this.game.add.sprite(500,1045,'overlayBg');
		botWall.scale.setTo(1,0.1);
		this.game.physics.p2.enable(botWall, false);
		botWall.body.static = true;
		botWall.alpha = 0;
    	// this.createPreviewBounds(bounds.x, bounds.y, bounds.width, bounds.height);
    	
    	powerBarBg = this.game.add.sprite(1600,200,'powerBarBg');

		
    	
    	leverBounds = new Phaser.Rectangle(1600, 260, 150, 650);

	    
	    
		if (striker == undefined) {
			striker = this.game.add.sprite(680, 865, 'striker');
			striker.anchor.set(0.5);
			striker.inputEnabled = true;
			striker.input.enableDrag();
			striker.input.allowVerticalDrag = false;
			striker.input.boundsRect = strikerBounds;
			striker.events.onDragStart.add(this.removeDirectionCircles, this);
			striker.events.onDragStop.add(this.selectAngle, this);
			// this.game.physics.p2.enable(striker, false);
		}
		
		cursors = this.game.input.keyboard.createCursorKeys();

	    
	    power = this.game.add.sprite(1648,830,'power');
	    power.scale.y = -1;
		lever = this.game.add.sprite(1615,260,'lever');
		
		empty = this.game.add.sprite(1672,844,'');
		
		pauseBtn = this.game.add.button(230, 60, 'pauseBtn', this.pauseGame, this);
		
		muteBtn = this.game.add.button(50, 30, 'muteBtn', toggleSound, this);
		if (isSoundOn == true)
			muteBtn.frame = 0;
		else
		muteBtn.frame = 1;
				
		overlay = this.game.add.sprite(0,0,'overlayBg');
		this.game.add.tween(overlay).to({alpha:0},700,Phaser.Easing.Linear.None).start();
		
		this.add.sprite(0, 0, '');
		
		// this.showGameOverPopup();
	},
	
	pauseGame:function(evt){
		if(gamePaused==false){
			gamePaused = true;
			evt.frame = 1;
			gamePausedBg = this.game.add.sprite(70,40,'gamePausedBg');
			
			menuBtn = this.game.add.button(600,550, 'menuBtn',this.loadMenu, this,1,0,1,1);
			menuBtn.scale.set(1.5,1.5);
			
			resumeBtn = this.game.add.button(950,550, 'resumeBtn',this.resumeGame, this,1,0,1,1);
			resumeBtn.scale.set(1.5,1.5);
			if(striker)
				striker.inputEnabled = false;
			lever.inputEnabled = false;
			if(directionCircle)
				directionCircle.inputEnabled = false;
			
			if(turn=='comp'){
				this.game.time.events.remove(timeEvent);
				timeEvent = undefined;
			}
		}
	},
	
	enableSpin:function(){
		spinEnabled = true;
	},
	
	disableSpin:function(){
		spinEnabled = false;
		spinDial.destroy();
	},
	
	resumeGame:function(){
		gamePaused = false;
		resumeBtn.destroy();
		menuBtn.destroy();
		gamePausedBg.destroy();
		lever.inputEnabled = true;
		
		if(turn=='comp')
			timeEvent = this.game.time.events.add(Phaser.Timer.SECOND * 1, this.aiTurn, this);
	},
	
	showGameOverPopup:function(){
		gameOverBg = this.game.add.sprite(0,0,'gameOverBg');
		this.game.add.tween(gameOverBg).to({alpha:1},500,Phaser.Easing.Linear.None).start();
		
		//Calculate Scores
		playerScore = playerCoins['whiteCoin'] + playerCoins['blackCoin'];
		compScore = compCoins['whiteCoin'] + compCoins['blackCoin'];
		
		submitMyScore(playerScore*100);
		console.log(playerScore);
		console.log(compScore);
		
		if(playerScore>compScore)
			winText = createText(this.game,750, 470, 'You Win! Your Score: '+(playerScore*100), '#fff', customFont3, 150, '#000', 5, false,0,false,true);
		else
			winText = createText(this.game,580, 470, 'Computer Wins! Player Score: '+(playerScore*100), '#fff', customFont3, 65, '#000', 5, false,0,false,true);
			
		menuBtn = this.game.add.button(850,725, 'menuBtn',this.loadMenu, this,1,0,1,1);
		
		nickLogo = this.game.add.sprite(775,850,'nickLogo');
		nickLogo.scale.set(0.5);
	},
	
	loadMenu:function(){
		gamePaused = false;
		buttonSound.play();
		window.location.reload();
	},
	
	coinHoleCollision:function(body, bodyB, shapeA, shapeB, equation){
		if(body.sprite){
			if(body.sprite.key=='striker'){
				if(turn=='player'){
					this.placeCoin();
					this.aiTurn();
				}
				else{
					this.placeCoin();
					this.resetStriker();
				}
				
			}
			else if((body.sprite.key=='whiteCoin' || body.sprite.key=='blackCoin') && coinsLeft==1 && queenDone==false){
				coinsLeft--;
				if(turn=='player'){
					playerCoins[body.sprite.key] += points[body.sprite.key];
					playerCoinsTxtObj[body.sprite.key].setText(playerCoins[body.sprite.key]);
					body.sprite.destroy();
					this.placeCoin();
					this.aiTurn();
				}
				else{
					compCoins[body.sprite.key] += points[body.sprite.key];;
					compCoinsTxtObj[body.sprite.key].setText(compCoins[body.sprite.key]);
					body.sprite.destroy();
					this.placeCoin();
					this.resetStriker();
				}
			}
			else{
				coinsLeft--;
				if(coinsLeft==-1){
					gameOverFlag = true;
					this.showGameOverPopup();
					winSound.play();
				}
				this.game.time.events.remove(timeEvent);
				timeEvent = undefined;
				if(turn=='player'){
					
					if(queenPocketed==true){
						queenPocketed = false;
						queenDone = true;
						playerCoins['whiteCoin']+=50;
						playerCoinsTxtObj['whiteCoin'].setText(playerCoins['whiteCoin']);
					}
					
					if(body.sprite.key=='queenCoin'){
						queenPocketed = true;
					}
					
					timeEvent = this.game.time.events.add(Phaser.Timer.SECOND * 6, this.resetStriker, this);
					if(queenPocketed==false){
						playerCoins[body.sprite.key]+= points[body.sprite.key];
						playerCoinsTxtObj[body.sprite.key].setText(playerCoins[body.sprite.key]);
					}
					
				}
				else{
					
					if(queenPocketed==true){
						queenPocketed = false;
						queenDone = true;
						compCoins['whiteCoin']+=50;
						compCoinsTxtObj['whiteCoin'].setText(compCoins['whiteCoin']);
					}
					
					if(body.sprite.key=='queenCoin'){
						queenPocketed = true;
					}
					
					timeEvent = this.game.time.events.add(Phaser.Timer.SECOND * 6, this.aiTurn, this);
					if(queenPocketed==false){
						compCoins[body.sprite.key]+=points[body.sprite.key];;
						compCoinsTxtObj[body.sprite.key].setText(compCoins[body.sprite.key]);
					}
				}
				body.sprite.destroy();
				
				if(queenPocketed==true)
					queenCoin = undefined;
			}
		}
	},
	
	
	createPreviewBounds:function(x, y, w, h) {

	    var sim = this.game.physics.p2;
	    var mask = sim.boundsCollisionGroup.mask;
	
	  	customBounds.left = new p2.Body({ mass: 0, position: [ sim.pxmi(x), sim.pxmi(y) ], angle: 1.5707963267948966 });
	    customBounds.left.addShape(new p2.Plane());
	    customBounds.left.shapes[0].collisionGroup = mask;
	
	    customBounds.right = new p2.Body({ mass: 0, position: [ sim.pxmi(x + w), sim.pxmi(y) ], angle: -1.5707963267948966 });
	    customBounds.right.addShape(new p2.Plane());
	    // customBounds.right.shapes[0].collisionGroup = mask;
	
	    customBounds.top = new p2.Body({ mass: 0, position: [ sim.pxmi(x), sim.pxmi(y) ], angle: -3.141592653589793 });
	    customBounds.top.addShape(new p2.Plane());
	    // customBounds.top.shapes[0].collisionGroup = mask;
	
	    customBounds.bottom = new p2.Body({ mass: 0, position: [ sim.pxmi(x), sim.pxmi(y + h) ] });
	    customBounds.bottom.addShape(new p2.Plane());
	
	    sim.world.addBody(customBounds.left);
	    sim.world.addBody(customBounds.right);
	    sim.world.addBody(customBounds.top);
	    sim.world.addBody(customBounds.bottom);
	},
	
	rotateBoard:function(){
		spinDial.rotation = this.game.physics.arcade.angleBetween(spinDial, this.game.input.activePointer);
		
		for(i=0;i<coins.length;i++){
			coins[i].rotation = spinDial.rotation;
		}
	},
	
	arrangeCoins:function(){
		queenCoin = this.game.add.sprite(948,540,'queenCoin');
		queenCoin.anchor.set(0.5);
		this.game.physics.p2.enable(queenCoin, false);
		queenCoin.body.setCircle(21);
		queenCoin.body.damping = 0.65;
		
		for(i=0;i<this.numCoins;i++){
			if(i%2==0)
				coins.push(this.game.add.sprite(948,540,'whiteCoin'));
			else
				coins.push(this.game.add.sprite(948,540,'blackCoin'));
			
			coins[coins.length-1].anchor.set(0.5);
		}
		
		coins[0].pivot.x = 48;coins[0].pivot.y = -5;
		coins[1].pivot.x = 33;coins[1].pivot.y = 40; 
		coins[2].pivot.x = -14;coins[2].pivot.y = 47;
		coins[3].pivot.x = -47;coins[3].pivot.y = 7
		coins[4].pivot.x = -35;coins[4].pivot.y = -39;
		coins[5].pivot.x = 14;coins[5].pivot.y = -47;
		
		//second circle
		coins[6].pivot.x = 96;coins[6].pivot.y = -10;
		coins[7].pivot.x = 84;coins[7].pivot.y = 37;
		coins[8].pivot.x = 62;coins[8].pivot.y = 80;
		coins[9].pivot.x = 14;coins[9].pivot.y = 90;
		coins[10].pivot.x = -33;coins[10].pivot.y = 89;
		coins[11].pivot.x = -68;coins[11].pivot.y = 52;
		coins[12].pivot.x = -94;coins[12].pivot.y = 14;
		coins[13].pivot.x = -84;coins[13].pivot.y = -34;
		coins[14].pivot.x = -66;coins[14].pivot.y = -78;
		coins[15].pivot.x = -16;coins[15].pivot.y = -89;
		coins[16].pivot.x = 32;coins[16].pivot.y = -91;
		coins[17].pivot.x = 69;coins[17].pivot.y = -54;
		
		
	},
	
	hitStriker:function(body, bodyB, shapeA, shapeB, equation){
		if(body==null)
			boardSound.play();
	},
	
	hitCoin:function(body, bodyB, shapeA, shapeB, equation){
		if(body!=null){
			if(body.sprite.key=='hole')
				holeSound.play();
			else
				hitSound.play();
		}
		else{
			boardSound.play();
		}
	},
	
	renderNewCoinsAndStriker:function(){
		for(i=0;i<coins.length;i++){
			if(i%2==0)
				newCoins.push(this.game.add.sprite(coins[i].world.x,coins[i].world.y,'whiteCoin'));
			else
				newCoins.push(this.game.add.sprite(coins[i].world.x,coins[i].world.y,'blackCoin'));
				
			newCoins[newCoins.length-1].anchor.set(0.5);
			
			this.game.physics.p2.enable(newCoins[newCoins.length-1], false);
			newCoins[newCoins.length-1].body.setCircle(21);
			newCoins[newCoins.length-1].body.damping = 0.65;
			newCoins[newCoins.length-1].body.onBeginContact.add(this.hitCoin, this);
			
			
			coins[i].destroy();
		}
		
		//COmmentttt
		// newCoins[newCoins.length-1].body = null;
		// newCoins[newCoins.length-1].x = 800;
		// newCoins[newCoins.length-1].y = 870;
		
		
	},
	
	removeDirectionCircles:function(){
		if(directionCircle!=undefined)
			directionCircle.destroy();
		
		if(analog!=undefined)
			analog.destroy();
	},
	
	
	selectAngle:function(){
		console.log(striker.x);
		for(i=0;i<newCoins.length;i++){
			if(this.game.physics.arcade.distanceBetween(striker, newCoins[i])<58){
				if(striker.x>1115)
					striker.x-=120;
				else
					striker.x+=110;
			}
		}
		if(striker.x>=688 && striker.x<=718){
			striker.x = 727;
		}
		if(striker.x>=1181 && striker.x<=1210){
			striker.x = 1172;
		}
		
		directionCircle = this.game.add.sprite(960,540,'direction');
		directionCircle.anchor.set(0.5);
		directionCircle.scale.set(1);
		directionCircle.inputEnabled = true;
		this.game.physics.enable(directionCircle, Phaser.Physics.ARCADE);
    	directionCircle.body.collideWorldBounds = true;
    	
    	directionCircle.events.onInputDown.add(this.startedDraggingCircle, this);
		directionCircle.events.onInputUp.add(this.stopDraggingCircle, this);
    	
    	analog = this.game.add.sprite(directionCircle.x,directionCircle.y, 'white');
    	this.game.physics.enable(analog, Phaser.Physics.ARCADE);
    	analog.body.allowGravity = false;
	    analog.height = 40;
	    analog.angle = 180/Math.PI * this.game.physics.arcade.angleBetween(striker,directionCircle);
	    analog.width = this.game.physics.arcade.distanceToPointer(directionCircle);
	    analog.alpha = 0.7;
	    analog.anchor.setTo(1, 0.5);
	    
	    lever.inputEnabled = true;
    	lever.input.enableDrag();
    	lever.input.allowHorizontalDrag = false;
    	lever.input.boundsRect = leverBounds;
    	lever.events.onDragStart.add(this.startDraggingLever, this);
		lever.events.onDragStop.add(this.stopDraggingLever, this);
	    
	},
	
	
	startedDraggingCircle:function(){
		directionCircle.body.moves = false;
	    directionCircle.body.velocity.setTo(0, 0);
	    directionCircle.body.allowGravity = false;
		isDragging = true;
	},
	
	
	stopDraggingCircle:function(){
		isDragging = false;
		// directionCircle.inputEnabled = false;
		
		//this.accelerateToObject(striker,directionCircle,avgSpeed);
	},
	
	
	startDraggingLever:function(){
		isDraggingLever = true;
	},
	
	
	stopDraggingLever:function(){
		isDraggingLever = false;
		if(power.scale.y<-0.85)
			power.scale.y-= 0.2;
		speed = 25 + (avgSpeed * (  1.2 +  power.scale.y));
		console.log(power.scale.y);
		directionCircle.destroy();
		analog.destroy();
		
		if(spinDial!=undefined){
			spinDial.destroy();
			spinDial = undefined;
			this.renderNewCoinsAndStriker();
		}
		
		this.game.physics.p2.enable(striker, false);
		striker.body.onBeginContact.add(this.hitStriker, this);
    	striker.body.setCircle(40);
    	striker.body.damping = 0.65;
		
		lever.inputEnabled = false;
		this.game.add.tween(lever).to({y:260},300,Phaser.Easing.Linear.None).start();
		this.game.add.tween(power.scale).to({y:-1},300,Phaser.Easing.Linear.None).start();
		this.accelerateToObject(striker,directionCircle,speed );
		
		timeEvent = this.game.time.events.add(Phaser.Timer.SECOND * 6, this.aiTurn, this);
	},
	
	aiTurn:function(){
		if(gameOverFlag==false){
			this.game.time.events.remove(timeEvent);
			timeEvent = undefined;
				
			if(queenPocketed==true)
				queenPocketed = false;
			//Queen and Follow is not done but just the queen is done
			if(queenDone==false && queenPocketed==false && queenCoin==undefined){
				this.placeQueenCoin();
			}
			
			
			this.game.time.events.remove(timeEvent);
			timeEvent = undefined;
			console.log("ai's turn");
			coinPlaced = false;
			placeee = false;
			turn = 'comp';
			minusCoinType = '';
			
			
			if(striker.body!=undefined)
				striker.body.destroy();
			striker.x = getRandomInt(700,1138);
			striker.y = 210;
	    	
	    	for(i=0;i<newCoins.length;i++){
	    		if(Math.floor(this.game.physics.arcade.distanceBetween(striker, newCoins[i]))<60){
	    			this.aiTurn();
	    			strikerAi = false;
	    			break;
	    		}
	    		else{
	    			strikerAi=true;
	    		}
	    	}
	    	
	    	if(strikerAi==true)
	    		timeEvent = this.game.time.events.add(Phaser.Timer.SECOND * 2, this.playerAiTurn, this);
    	}
	},
	
	placeQueenCoin:function(){
			console.log("Placing Queen Coin");
			coinsLeft++;
			placeee = true;
			xPos = Math.floor(getRandomInt(853,1047));
			yPos = Math.floor(getRandomInt(433,616));
			minusCoin = undefined;
			if(firstQueenPlace ==false){
				firstQueenPlace = true;
				minusCoin = this.game.add.sprite(948,540,'queenCoin');
			}
			else{
				minusCoin = this.game.add.sprite(xPos,yPos,'queenCoin');
			}
				for(i=0;i<newCoins.length;i++){
		    		if(Math.floor(this.game.physics.arcade.distanceBetween(minusCoin, newCoins[i]))<60){
		    			minusCoin.destroy();
		    			this.placeQueenCoin();
		    			coinPlaced = false;
		    			break;
		    		}
		    		else{
		    			coinPlaced=true;
		    		}
		    	}
		  	
	    		if(coinPlaced==true){
		    		queenCoin = minusCoin;
		    		queenCoin.anchor.set(0.5);
					
					this.game.physics.p2.enable(queenCoin, false);
					queenCoin.body.setCircle(23);
					queenCoin.body.damping = 0.65;
				}
		
	},
	
	
	
	placeCoin:function(){
		if(placeee==false)
		{
			placeee = true;
			xPos = Math.floor(getRandomInt(820,1060));
			yPos = Math.floor(getRandomInt(420,640));
			
			
			if(turn=='player' && (playerCoins['whiteCoin']>0 || playerCoins['blackCoin']>0)){
				if(playerCoins['blackCoin']>0){
					playerCoins['blackCoin']-=10;
					minusCoinType = 'blackCoin';
					playerCoinsTxtObj['blackCoin'].setText(playerCoins['blackCoin']);
				}
				else{
					playerCoins['whiteCoin']-=20;
					minusCoinType = 'whiteCoin';
					playerCoinsTxtObj['whiteCoin'].setText(playerCoins['whiteCoin']);
				}
			}
			else if(turn=='comp' && (compCoins['whiteCoin']>0 || compCoins['blackCoin']>0)){
				if(compCoins['blackCoin']>0){
					compCoins['blackCoin']-=10;
					compCoinsTxtObj['blackCoin'].setText(compCoins['blackCoin']);
					minusCoinType = 'blackCoin';
				}
				else{
					compCoins['whiteCoin']-=20;
					minusCoinType = 'whiteCoin';
					compCoinsTxtObj['whiteCoin'].setText(compCoins['whiteCoin']);
				}
			}
			
			if(minusCoinType !=''){
				minusCoin = this.game.add.sprite(xPos,yPos,minusCoinType);
				for(i=0;i<newCoins.length;i++){
					if(newCoins[i].game!=null){
			    		if(this.game.physics.arcade.distanceBetween(minusCoin, newCoins[i])<57){
			    			minusCoin.destroy();
			    			coinPlaced = false;
			    			placeee = false;
			    			break;
			    		}
			    		else{
			    			coinPlaced=true;
			    		}
		    		}
		    	}
		  	}
	    	
	    	if(coinsLeft==0){
	    		coinPlaced=true;
	    	}
	    	
	    	if(coinPlaced==false){
	    		console.log("truing again");
	    		this.placeCoin();
	    	}
	    	else{
	    		console.log("Placing COin");
	    		coinsLeft++;
	    		
	    		// this.game.add.tween(minusCoin).to({alpha:0.1},200,Phaser.Easing.Linear.None)
	    										// .to({alpha:1},200,Phaser.Easing.Linear.None).loop().start();
	    		
	    		newCoins.push(this.game.add.sprite(minusCoin.x,minusCoin.y,minusCoinType));
	    		newCoins[newCoins.length-1].anchor.set(0.5);
	    		console.log("")
	    		minusCoin.destroy();
	    	}
		}	
		
	},
	
	playerAiTurn:function(){
		strikerAi = false;
		this.game.physics.p2.enable(striker, false);
		striker.body.onBeginContact.add(this.hitStriker, this);
    	striker.body.setCircle(40);
    	striker.body.damping = 0.65;
    	
		speed = 25 + (avgSpeed * (getRandomFloat(0.7,0.9)));
		
		coinSelected = false;
		ctr = 0;
		while(coinSelected==false){
			randomCoin = newCoins[ctr];
			if(randomCoin.game!=null){
				coinSelected = true;
				this.accelerateToObject(striker,randomCoin,speed );
				timeEvent = this.game.time.events.add(Phaser.Timer.SECOND * 6, this.resetStriker, this);
			}
			else{
				ctr++;
			}
		}
		
		
		
	},
	
	resetStriker:function(){
		if(gameOverFlag==false){
			this.game.time.events.remove(timeEvent);
			timeEvent = undefined;
			//Queen and Follow is not done but just the queen is done
			if(queenDone==false && queenPocketed==false && queenCoin==undefined){
				this.placeQueenCoin();
			}
			
			strikerAi = false;
			console.log("Restting to player");
			minusCoinType = '';
			placeee = false;
			coinPlaced = false;
			turn='player';
			if(striker.body)
				striker.body.destroy();
			striker.x = 750;
			striker.y = 865;
			striker.inputEnabled = true;
		}
	},
	
	
	accelerateToObject:function(obj1, obj2, speed) {
		
		striker.inputEnabled = false;
		firstQueenPlace = false;
		
		this.game.physics.p2.enable(newCoins[newCoins.length-1], false);
	    newCoins[newCoins.length-1].body.setCircle(23);
	    newCoins[newCoins.length-1].body.damping = 0.65;
	    
	    if (typeof speed === 'undefined') { speed = 60; }
	    var angle = Math.atan2(obj2.y - obj1.y, obj2.x - obj1.x);
    	obj1.body.rotation = angle + this.game.math.degToRad(90);  // correct angle of angry
	    
	    obj1.body.force.x = Math.cos(angle) * (speed * speed * speed);    // accelerateToObject 
	    obj1.body.force.y = Math.sin(angle) * (speed * speed * speed);
	},
	
	
	update:function(){
		// if(!this.game.scale.isLandscape) {
			// handleIncorrect();	
		// } else if(this.game.scale.isLandscape) {
			// handleCorrect();
        // }
        
        if (cursors.left.isDown)
	    {
	        striker.body.moveLeft(200);
	    }
	    else if (cursors.right.isDown)
	    {
	        striker.body.moveRight(200);
	    }
	
	    if (cursors.up.isDown)
	    {
	        striker.body.moveUp(200);
	    }
	    else if (cursors.down.isDown)
	    {
	        striker.body.moveDown(200);
	    }
        
		if(gamePaused==false)
		{	
			if (this.game.input.activePointer.isDown) {
				 // console.log(this.game.input.activePointer.x+" "+this.game.input.activePointer.y);
				if(spinDial!=undefined){
					if(spinEnabled==true){
						spinning = true;	
						this.rotateBoard();	
					}
				}
			}
			else{
				if(spinning==true){
					spinning = false;

				}
			}
	
			if(isDraggingLever==true){
				if(this.game.input.activePointer.y>283 && this.game.input.activePointer.y<784)
					power.height = -this.game.physics.arcade.distanceToPointer(empty);
			}
			
						
			if(directionCircle!=undefined){
				this.game.world.bringToTop(analog);
				this.game.world.bringToTop(directionCircle);
			}
			
			if (isDragging == true)
		    {
		       if((this.game.input.activePointer.x>502 && this.game.input.activePointer.x<1394)&&(this.game.input.activePointer.y>99 && this.game.input.activePointer.y<989)){     
			        directionCircle.x = this.game.input.activePointer.x;   
		        	directionCircle.y = this.game.input.activePointer.y;
		        	
		        	analog.alpha = 0.7;
		        	analog.x = directionCircle.x;
		        	analog.y = directionCircle.y;
		        	
				    analog.angle = 180/Math.PI * this.game.physics.arcade.angleBetween(striker,directionCircle);
				    analog.width = this.game.physics.arcade.distanceToPointer(striker);
			    }
		    } 
	   	}
	},
	
}
